//*****************************************************************************
// file mod_car.cpp
#include <libce.h>

// contatore 0 dello 8259 collegato al piedino n. 0 dello IO APIC
// (in alcuni emulatori, tale contatore risulta collegato al piedino n. 2)

const ioaddr iCWR = 0x43;
const ioaddr iCTR0_LSB = 0x40;
const ioaddr iCTR0_MSB = 0x40;

// semaforo numero 2
const natl sincr_t = 2;
natl num_t;

void ini_ip_CONT0()
{
	// costante di tempo relativa a 50 ms
	natl N = 59500;	
	// contatore 0 in modo 3
	outputb(0x36, iCWR);
	outputb(N, iCTR0_LSB);				
	outputb(N >> 8, iCTR0_MSB);
}
// indirizzo da porre nel gate n. 240
extern "C" void a_go_timer();
// indirizzo da porre nel gate  n. 40
extern "C" void a_driver_timer();
void ini()
{
	gate_init(242, a_go_timer);
	gate_init(42, a_driver_timer);
	// piedino 2 associato al tipo 40
	apic_set_VECT(2, 42);
	ini_ip_CONT0();
}

extern "C" void c_go_timer(natl num)
{
	num_t = num;
	// abilit. piedino IRQ_t dello IO APIC
	apic_set_MIRQ(2, false);
	sem_wait(sincr_t);
}

extern "C" void c_driver_timer()
{
	char_write('D');
	num_t--;
	if (num_t == 0) {
		// disab. piedino 2 dello IO APIC
		apic_set_MIRQ(2, true);
		sem_signal(sincr_t);
	}
}
//*****************************************************************************
